pangomm: Pango::AttrShape Class Reference

pangomm 2.56.1

Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Pango::AttrShape Class Reference

A Pango::AttrShape structure is used to represent an attribute which imposes shape restrictions. More...

`#include <pangomm/attributes.h>`

Inheritance diagram for Pango::AttrShape:
[legend]

## Public Member Functions
| AttrShape (const AttrShape & src)
| AttrShape (PangoAttrShape * castitem, bool take_copy=true)
AttrShape & | operator= (const AttrShape & src)
Rectangle | get_ink_rect () const
| Gets the ink rectangle to restrict to.
Rectangle | get_logical_rect () const
| Gets the logical rectangle to restrict to.
void | set_ink_rect (const Rectangle & value)
| Sets the ink rectangle to restrict to.
void | set_logical_rect (const Rectangle & value)
| Sets the logical rectangle to restrict to.
PangoAttrShape * | gobj ()
| Provides access to the underlying C GObject.
const PangoAttrShape * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Pango::Attribute
| Attribute ()
| Constructs an invalid attribute.
| Attribute (const Attribute & src)
| Attribute (PangoAttribute * castitem, bool take_copy=true)
| ~Attribute ()
Attribute & | operator= (const Attribute & src)
AttrType | get_type () const
| Gets the type ID for this attribute.
unsigned int | get_start_index () const
| Gets the start index of the range.
unsigned int | get_end_index () const
| Gets the end index of the range.
void | set_start_index (const unsigned int & value)
| Sets the start index of the range.
void | set_end_index (const unsigned int & value)
| Sets the end index of the range.
bool | equal (const Attribute & attr2) const
| Compare two attributes for equality.
PangoAttribute * | gobj ()
| Provides access to the underlying C GObject.
const PangoAttribute * | gobj () const
| Provides access to the underlying C GObject.

## Protected Member Functions
| AttrShape ()

## Related Symbols
(Note that these are not member symbols.)
Pango::AttrShape | wrap (PangoAttrShape * object, bool take_copy=false)
Related Symbols inherited from Pango::Attribute
bool | operator== (const Attribute & lhs, const Attribute & rhs)
bool | operator!= (const Attribute & lhs, const Attribute & rhs)
Pango::Attribute | wrap (PangoAttribute * object, bool take_copy=false)

## Additional Inherited Members
Static Public Member Functions inherited from Pango::Attribute
static AttrType | register_type (const Glib::ustring & name)
| Allocate a new attribute type ID.
static Glib::ustring | get_type_name (AttrType type)
| Fetches the attribute type name passed in when registering the type using register_type().
static AttrString | create_attr_family (const Glib::ustring & family)
| Create a new font family attribute.
static AttrLanguage | create_attr_language (const Language & language)
| Create a new language tag attribute.
static AttrColor | create_attr_foreground (guint16 red, guint16 green, guint16 blue)
| Create a new foreground color attribute.
static AttrColor | create_attr_background (guint16 red, guint16 green, guint16 blue)
| Create a new background color attribute.
static AttrInt | create_attr_foreground_alpha (guint16 alpha)
| Create a new foreground alpha attribute.
static AttrInt | create_attr_background_alpha (guint16 alpha)
| Create a new background alpha attribute.
static AttrInt | create_attr_size (int size)
| Create a new font-size attribute.
static AttrInt | create_attr_size_absolute (int size)
| Create a new font-size attribute.
static AttrInt | create_attr_style (Style style)
| Create a new font slant style attribute.
static AttrInt | create_attr_weight (Weight weight)
| Create a new font weight attribute.
static AttrInt | create_attr_variant (Variant variant)
| Create a new font variant attribute (normal or small caps).
static AttrInt | create_attr_stretch (Stretch stretch)
| Create a new font stretch attribute.
static AttrFontDesc | create_attr_font_desc (const FontDescription & desc)
| Create a new font description attribute.
static AttrInt | create_attr_underline (Underline underline)
| Create a new underline-style object.
static AttrColor | create_attr_underline_color (guint16 red, guint16 green, guint16 blue)
| Create a new underline color attribute.
static AttrInt | create_attr_overline (Overline overline)
| Create a new overline-style object.
static AttrColor | create_attr_overline_color (guint16 red, guint16 green, guint16 blue)
| Create a new overline color attribute.
static AttrInt | create_attr_strikethrough (bool strikethrough)
| Create a new font strike-through attribute.
static AttrColor | create_attr_strikethrough_color (guint16 red, guint16 green, guint16 blue)
| Create a new strikethrough color attribute.
static AttrInt | create_attr_rise (int rise)
| Create a new baseline displacement attribute.
static AttrInt | create_attr_baseline_shift (int shift)
| Create a new baseline displacement attribute.
static AttrInt | create_attr_font_scale (FontScale scale)
| Create a new font scale attribute.
static AttrFloat | create_attr_scale (double scale_factor)
| Create a new font size scale attribute.
static AttrInt | create_attr_fallback (bool enable_fallback)
| Create a new font fallback attribute.
static AttrInt | create_attr_letter_spacing (int letter_spacing)
| Create a new letter-spacing attribute.
static AttrShape | create_attr_shape (const Rectangle & ink_rect, const Rectangle & logical_rect)
| Create a new shape attribute.
static AttrInt | create_attr_gravity (Gravity gravity)
| Create a new gravity attribute.
static AttrInt | create_attr_gravity_hint (GravityHint hint)
| Create a new gravity hint attribute.
static AttrString | create_attr_font_features (const Glib::ustring & features)
| Create a new font features tag attribute.
static AttrInt | create_attr_allow_breaks (bool allow_breaks)
| Create a new allow-breaks attribute.
static AttrInt | create_attr_word ()
| Marks the range of the attribute as a single word.
static AttrInt | create_attr_sentence ()
| Marks the range of the attribute as a single sentence.
static AttrInt | create_attr_insert_hyphens (bool insert_hyphens)
| Create a new insert-hyphens attribute.
static AttrInt | create_attr_show (ShowFlags show)
| Create a new attribute that influences how invisible characters are rendered.
static AttrFloat | create_attr_line_height (double factor)
| Modify the height of logical line extents by a factor.
static AttrInt | create_attr_line_height_absolute (int height)
| Override the height of logical line extents to be height.
static AttrInt | create_attr_text_transform (TextTransform transform)
| Create a new attribute that influences how characters are transformed during shaping.
Protected Attributes inherited from Pango::Attribute
PangoAttribute * | gobject_

## Detailed Description

A Pango::AttrShape structure is used to represent an attribute which imposes shape restrictions.

## Constructor & Destructor Documentation

## ◆ AttrShape() [1/3]

Pango::AttrShape::AttrShape | ( |  | ) |
| protected

## ◆ AttrShape() [2/3]

Pango::AttrShape::AttrShape | ( | const AttrShape & | src | ) |

## ◆ AttrShape() [3/3]

Pango::AttrShape::AttrShape | ( | PangoAttrShape * | castitem,
|  | bool | take_copy = true )
| explicit

## Member Function Documentation

## ◆ get_ink_rect()

Rectangle Pango::AttrShape::get_ink_rect | ( |  | ) | const

Gets the ink rectangle to restrict to.

Returns
  The ink rectangle of the attribute.

## ◆ get_logical_rect()

Rectangle Pango::AttrShape::get_logical_rect | ( |  | ) | const

Gets the logical rectangle to restrict to.

Returns
  The logical rectangle of the attribute.

## ◆ gobj() [1/2]

PangoAttrShape * Pango::AttrShape::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const PangoAttrShape * Pango::AttrShape::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=()

AttrShape & Pango::AttrShape::operator= | ( | const AttrShape & | src | ) |

## ◆ set_ink_rect()

void Pango::AttrShape::set_ink_rect | ( | const Rectangle & | value | ) |

Sets the ink rectangle to restrict to.

Parameters

  value | The new ink rectangle for the attribute.

## ◆ set_logical_rect()

void Pango::AttrShape::set_logical_rect | ( | const Rectangle & | value | ) |

Sets the logical rectangle to restrict to.

Parameters

  value | The new logical rectangle for the attribute.

## Friends And Related Symbol Documentation

## ◆ wrap()

Pango::AttrShape wrap | ( | PangoAttrShape * | object,
|  | bool | take_copy = false )
| related